<template>
  <div
    id="tree-share"
  >
    <Tree
      :data="treeDataAll"
      :props="option"
      show-checkbox
      :default-expand-all="isOpenAll"
      @check="handleNodeClick"
      highlight-current
      :check-on-click-node="true"
      :check-strictly="false"
      :render-content="renderContent"
      id="tree"
      ref="treeShare"
      node-key="id"
      :filter-node-method="filterNode"
    />
  </div>
</template>

<script>
import { Tree, Button } from 'element-ui'
export default {
  name: 'ShareTree',
  data: () => ({
    treeDataAll: [],
    searchValue: '',
    nodeStatus: {}
  }),
  props: {
    data: {
      type: String,
      default: ''
    },
    option: {
      type: Object,
      default: () => ({
        children: 'child',
        label: 'name'
      })
    },
    isOpenAll: {
      default: true,
      type: Boolean
    },
    index: {
      type: Number,
      required: false,
      default: 0
    }
  },
  watch: {
    // data: {
    //   handler(newValue, oldValue) {
    //     console.log(newValue, '子组件监听实时变化数据')
    //   }
    // }
  },
  mounted() {
    this.treeDataAll = JSON.parse(this.data)
  },
  methods: {
    handleNodeClick(node) {
      console.log(node, '设备树勾选事件')
      if (node.isCheck) {
        this.haveChildFalse(node)
      } else {
        this.haveChildTrue(node)
      }
      let checkNodes = this.$refs.treeShare.getCheckedNodes()
      this.$emit('currentNode', this.data, node, checkNodes)
    },
    haveChildTrue(node) {
      this.$set(node, 'isCheck', true)
      if (node && node.children && node.children.length !== 0) {
        node.children.forEach((item, index) => {
          this.haveChildTrue(item)
        })
      }
    },
    haveChildFalse(node) {
      this.$set(node, 'isCheck', false)
      if (node && node.children && node.children.length !== 0) {
        node.children.forEach((item, index) => {
          this.haveChildFalse(item)
        })
      }
    },
    // * 设置选中状态
    setCurrentKey(ids) {
      // console.log(ids, '设置选中状态 ids')
      // this.$refs.treeShare.setCheckedKeys([])
      // if (ids && ids.length !== 0) {
      //   ids.forEach((item, index) => {
      //     console.log(item, '设置选中状态 item')
      //     // this.$refs.treeShare.setChecked(item[index]['id'], true)
      //     this.$nextTick(() => {
      //       this.$refs.treeShare.setChecked(item['id'], true)
      //     })
      //   })
      // }
      if (ids && ids.length !== 0) {
        ids.forEach((i, index) => {
          this.$refs.treeShare.setChecked(i, true)
        })
      }
    },
    /** 全部取消勾选 */
    cancleCheck() {
      this.$refs.treeShare.setCheckedKeys([])
    },
    // * 设置选中状态
    setCurrentKeyOne(id) {
      console.log(id, '设置选中的集群节点')
      this.$refs.treeShare.setChecked(id, true)
    },
    // * 设置选中状态,希望同时改变节点颜色
    setKeyOneAndClass(data) {
      console.log(data, '设置树节点颜色')
      let keys = {}
      let errorkeys = []
      let sukeys = []
      this.nodeStatus = {}
      /** 判断传过来的对象是数组还是Object */
      if (data instanceof Array) {
        if (data && data.length !== 0) {
          data.forEach((item) => {
          /** 判断该节点是否分享成功 */
            if (item.isSuccess === -1) {
              errorkeys.push(item.uuid)
              console.log(errorkeys, 'errorkeys')
              this.$set(keys, 'errorkeys', errorkeys)
            } else {
              sukeys.push(item.uuid)
              this.$set(keys, 'sukeys', sukeys)
            }
          })
        }
      } else {
        if (data.notDataBase && data.notDataBase.length !== 0) {
          data.notDataBase.forEach(item => {
            this.setCurrentKeyOne(item.uuid)
            sukeys.push(item.uuid)
          })
          this.$set(keys, 'sukeys', sukeys)
        } else if (data.existDataBase && data.existDataBase.length !== 0) {
          data.existDataBase.forEach(item => {
            this.setCurrentKeyOne(item.uuid)
            errorkeys.push(item.uuid)
          })
          this.$set(keys, 'errorkeys', errorkeys)
        } else {
          if (data.allDataBase && data.allDataBase.length !== 0) {
            data.allDataBase.forEach(item => {
              this.setCurrentKeyOne(item.uuid)
            })
          }
        }
      }

      console.log(keys, 'keys')
      this.nodeStatus = keys
    },
    // 清空选中状态
    removeCurrentNode(data) {
      console.log(data, '进入清空选中状态')
      if (data && data.length !== 0) {
        let keys = []
        data.forEach(item => {
          keys.push(item)
        })
        console.log(keys, '存储的选中的keys')
        keys.forEach(item => {
          this.$refs.treeShare.setChecked(item, false)
        })

        // this.$refs.treeShare.setCheckedNodes(null)
      } else {
        this.$refs.treeShare.setCheckedKeys([])
      }
    },
    /** 根据指定的id数组取消勾选 */
    removeCheck(data, node) {
      if (data && data.length !== 0) {
        data.forEach(i => {
          this.$refs.treeShare.setChecked(i, false)
        })
        /** 清除第一颗树的选中效果后 */
        this.handleNodeClick(node)
      }
    },
    // * 过滤
    handleSearch() {
      this.$refs.treeShare.filter(this.searchValue)
    },
    // * 过滤
    filterNode(value, data) {
      if (!value) return true
      return data.name.indexOf(value) !== -1
    },
    // * 获取被选中节点
    getCurrentNode() {
      return this.$refs.treeShare.getCurrentNode()
    },
    // 获取被选中的所有节点
    getCurrentNodes() {
      return this.$refs.treeShare.getCheckedNodes()
    },
    // 接触禁用状态
    unDisabled(data) {
      console.log(data, '解除禁用')
      this.data = data
    },
    renderContent(h, { node, data, store }) {
      // console.log(node, 'renderContent node')
      // console.log(data, 'renderContent data')
      // console.log(store, 'renderContent store')
      let nodes = this.nodeStatus
      if (Object.keys(nodes).length !== 0) {
        /** 不为空说明有数据 */
        let sukeys = nodes.sukeys
        let errorkeys = nodes.errorkeys
        if (sukeys && sukeys.length !== 0) {
          /** 判断第一级节点是否存在 */
          if (sukeys.indexOf(data.id) !== -1) {
            return (<span style="color:green">{node.label}</span>)
          }
          if (sukeys.indexOf(data.id) === -1) {
            return (<span>{node.label}</span>)
          }
          /** 判断第二级节点 */
          if (data.children && data.children.length !== 0) {
            data.children.forEach((item) => {
              if (sukeys.indexOf(item.id) !== -1) {
                return (<span style="color:green">{node.label}</span>)
              }
              if (sukeys.indexOf(item.id) === -1) {
                return (<span>{node.label}</span>)
              }
              /** 判断第三级节点 */
              if (item && item.children.length !== 0) {
                item.children.forEach((x) => {
                  if (sukeys.indexOf(x.id) !== -1) {
                    return (<span style="color:green">{node.label}</span>)
                  } else {
                    return (<span>{node.label}</span>)
                  }
                })
              }
            })
          }
        }
        if (errorkeys && errorkeys.length !== 0) {
          /** 判断第一级节点是否存在 */
          if (errorkeys.indexOf(data.id) !== -1) {
            return (<span style="color:red">{node.label}</span>)
          }
          if (errorkeys.indexOf(data.id) === -1) {
            return (<span>{node.label}</span>)
          }
          /** 判断第二级节点 */
          if (data.children && data.children.length !== 0) {
            data.children.forEach((item) => {
              if (errorkeys.indexOf(item.id) !== -1) {
                return (<span style="color:red">{node.label}</span>)
              }
              if (errorkeys.indexOf(item.id) === -1) {
                return (<span>{node.label}</span>)
              }
              /** 判断第三级节点 */
              if (item && item.children.length !== 0) {
                item.children.forEach((x) => {
                  if (errorkeys.indexOf(x.id) !== -1) {
                    return (<span style="color:red">{node.label}</span>)
                  } else {
                    return (<span>{node.label}</span>)
                  }
                })
              }
            })
          }
        }
      } else {
        return (<span>{node.label}</span>)
      }
    }
  },
  components: {
    Tree,
    elButton: Button
  }
}
</script>

<style lang="scss" socped>
#tree-share{
  .el-tree-node .el-tree-node__content {
    line-height: 40px;
    height: 40px;
    font-size: 18px;
    border-radius: 2px;
    position: relative;
    .el-checkbox {
      margin-bottom: 0;
    }
    .el-tree-node__expand-icon {
      font-size: 20px;
      position: absolute;
      top: 4px;
      right: 0px;
      -webkit-transform: rotate(180deg);
      transform: rotate(180deg);
    }
    .el-tree-node__expand-icon.expanded {
      -webkit-transform: rotate(90deg);
      transform: rotate(90deg);
    }
  }
  #tree > .el-tree-node > :first-child.el-tree-node__content {
    background: #35bde7;
    color: #fff;
    // color: brown;
    .el-tree-node__expand-icon {
      color: #fff;
    }
    .el-checkbox {
      margin-left: 10px;
    }
  }
  #tree
    > .el-tree-node
    > .el-tree-node__children
    > .el-tree-node
    > :first-child.el-tree-node__content {
    background: #f8f8f8;
  }
  .el-checkbox__input.is-checked .el-checkbox__inner, .el-checkbox__input.is-indeterminate .el-checkbox__inner {
      background-color: #fff;
      border-color: #fff;
  }
  .el-checkbox__input.is-checked .el-checkbox__inner::after {
    border-color: #333;
  }

}

.redClass{
  color: red;
}
</style>
